package org.jconfig.visual;

import java.awt.event.*;
import javax.swing.*;
import org.jconfig.items.*;

/**
 *  <p>package:    org.jconfig.visual</p>
 *  <p>file:       ConfigCheckBox.java</p>
 * $Id: ConfigPasswField.java,v 1.2 2004/04/19 08:12:45 tgl Exp $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 *	Password widget for configuration editor
 * </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0
 */
public class ConfigPasswField extends JPasswordField {
    
    public String   id;    
    public TreeItem item;
    
    /** Creates a new instance of ConfigTextArea */
    public ConfigPasswField(TreeItem it, String name, int ulevel) {
        item = it;
        id = name;

        String txt = it.GetOrBuildAttrValue(id);
        setText (txt);

        this.setEnabled(ConfigPanel.ConfigCheckUserlevel(it, ulevel));
        
        addFocusListener(new FocusListener() {
            public void focusGained(FocusEvent e) {}
            
            public void focusLost(FocusEvent e) {
                item.ModifyAttr(id, getPassword().toString());
            }
        });
    }
}
