package org.jconfig.visual;

import java.awt.event.*;
import javax.swing.*;
import org.jconfig.items.*;

/**
 *  <p>package:    org.jconfig.visual</p>
 *  <p>file:       ConfigTextArea.java</p>
 * $Id: ConfigTextArea.java,v 1.2 2004/04/19 08:12:45 tgl Exp $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 *	Textarea widget for configuration editor
 * </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0
 */
public class ConfigTextArea extends JTextArea {
    
    public boolean  istext;
    public String   id;    
    public TreeItem item;
    
    /** Creates a new instance of ConfigTextArea */
    public ConfigTextArea(int row, int col, TreeItem it, boolean isText, String name, int ulevel) {
        item = it;
        istext = isText;
        id = name;
        
        setRows (row);
        setColumns (col);
        
        if (isText) {
            for (int i = 0; i < it.text.size(); i++)
                append((String)it.text.get(i)+"\n"); 
        }

        this.setEnabled(ConfigPanel.ConfigCheckUserlevel(it, ulevel));
        
        addFocusListener(new FocusListener() {
            public void focusGained(FocusEvent e) {}
            
            public void focusLost(FocusEvent e) {
                String txt[] = getText().split("\n");
                if (istext) {
                    for (int i = 0; i < txt.length; i++) {
                        if (i < item.text.size())
                            item.text.set(i,txt[i]);
                        else
                            item.text.add(txt[i]);
                    }
                }
            }
        });
    }
    
}
