package org.jconfig.visual;

import java.awt.event.*;
import javax.swing.*;
import org.jconfig.items.*;

/**
 *  <p>package:    org.jconfig.visual</p>
 *  <p>file:       ConfigTextField.java</p>
 * $Id: ConfigTextField.java,v 1.2 2004/04/19 08:12:45 tgl Exp $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 *	Textfield widget for configuration editor
 * </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0
 */
public class ConfigTextField extends JTextField {
    
    public String   id;    
    public TreeItem item, cfgitem;
    
    /** Creates a new instance of ConfigTextArea */
    public ConfigTextField(TreeItem it, TreeItem cfg, String name, int ulevel) {
        item = it;
        id = name;
        cfgitem = cfg;
        String txt;
        
        if (cfgitem.CheckAttrValue("storecontent", "true"))
            txt = it.GetContent();
        else    
            txt = it.GetOrBuildAttrValue(id);
        setText (txt);

        this.setEnabled(ConfigPanel.ConfigCheckUserlevel(it, ulevel));
        
        addFocusListener(new FocusListener() {
            public void focusGained(FocusEvent e) {}
            
            public void focusLost(FocusEvent e) {
                if (cfgitem.CheckAttrValue("storecontent", "true"))
                    item.SetContent(getText());
                else
                    item.ModifyAttr(id, getText());
            }
        });
    }
}
