/*
 * JVConfig.java
 *
 * Created on 19. Oktober 2003, 21:17
 */

package org.jvisu.applets;

import java.net.*;
import org.jvisu.base.*;
import org.jvisu.util.*;
import javax.swing.*;

/** Configuration editor applet
 *
 *  <p>package:  org.jvisu.applets</p>
 *  <p>file:    JVConfig.java</p>
 *  <p>$Id: JVConfig.java,v 1.4 2004/04/19 08:20:55 tgl Exp $ </p>
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 *  <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation. See file LICENCE in this
 *  directory</p>
 *  
 *  <p>Change Log:</p>
 *  <ul>
 *  <li> 1.0 Initial inmplimentation </li>
 *  </ul>
 *  <p>
 *  Configuration editor applet
 *  </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0 
*/
public class JVConfig extends javax.swing.JApplet {
    
    private int userlevel;
    /* Password strings for userlevel access*/
    private String[] passwords = {"","passwordlevel1","passwordlevel2" };

    private JVBool update = null;	
    
    /* Configuration file name */
    String configfile;
    
    /** Initializes the applet JVConfig */
    public void init() {
        initComponents();
        URL base = this.getDocumentBase();
        String conf = getParameter("configfile");
        ConfTree.setUsername("silocontrol");
        ConfTree.setPassword("silo1234");
        String serv = getParameter("server");
        if (serv == null)
            serv = base.getHost();
        if (conf != null) {
            String proto = getParameter("protocol");
            if (proto == null)
                proto = "http://";
            configfile = proto + serv + conf;
            System.out.println(configfile);
            ConfTree.setConfigFile(configfile);
        }
	ConfTree.setEditEnabled(true);
	String par = getParameter("update");
	if (par != null) {
		update = new JVBool();
		update.setCommVar(par);
		par = getParameter("port");
		update.setPort (org.jvisu.util.param.JVParams.StringToInt(par, 2200));
		update.setServer (serv);
		update.setCommtype("org.jvisu.comm.JVSockComm");
                getContentPane().add(update, java.awt.BorderLayout.SOUTH);
                update.setVisible(false);
	}	
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        ConfTree = new org.jvisu.base.JVConfig();
        jMenuBar1 = new javax.swing.JMenuBar();
        FileMenu = new javax.swing.JMenu();
        MenuSave = new javax.swing.JMenuItem();
        MenuUserlevel = new javax.swing.JMenuItem();
        MenuLoadBackup = new javax.swing.JMenuItem();

        getContentPane().add(ConfTree, java.awt.BorderLayout.CENTER);

        FileMenu.setText("Datei");
        MenuSave.setText("Speichern");
        MenuSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuSaveActionPerformed(evt);
            }
        });

        FileMenu.add(MenuSave);

        MenuUserlevel.setText("Benutzerebene");
        MenuUserlevel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuUserlevelActionPerformed(evt);
            }
        });

        FileMenu.add(MenuUserlevel);

/*
        MenuLoadBackup.setText("Sicherungsdatei laden");
        MenuLoadBackup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuLoadBackupActionPerformed(evt);
            }
        });

        FileMenu.add(MenuLoadBackup);
*/
        jMenuBar1.add(FileMenu);

        setJMenuBar(jMenuBar1);

    }

    private void MenuLoadBackupActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        ConfTree.LoadBackupFile(configfile + ".bak");
    }

    private void MenuUserlevelActionPerformed(java.awt.event.ActionEvent evt) {
        int newlevel = userlevel;
        // Add your handling code here:
        Object[] possibilities = {"0", "1", "2"};
        String s = (String)JOptionPane.showInputDialog(
                    this.getContentPane(),
                    "Bitte Benutzerebene waehlen",
                    "Benutzerebene",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    possibilities,
                    Integer.toString(userlevel));
        try {
            newlevel = Integer.parseInt(s);
        } catch ( NumberFormatException e ) { return; }
        if (newlevel > userlevel) {
            s = (String)JOptionPane.showInputDialog(
                    this.getContentPane(),
                    "Bitte Passwort eingeben",
                    "Password",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    null,
                    "");
            if (s.compareTo(passwords[newlevel]) != 0)
                return;
        }
        userlevel = newlevel;
        ConfTree.setUserlevel(userlevel);

    }

    private void MenuSaveActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        ConfTree.SaveTree();
	if (update != null) {
		update.setValue(true);
	}	
    }
    
    
    private org.jvisu.base.JVConfig ConfTree;
    private javax.swing.JMenu FileMenu;
    private javax.swing.JMenuItem MenuLoadBackup;
    private javax.swing.JMenuItem MenuSave;
    private javax.swing.JMenuItem MenuUserlevel;
    private javax.swing.JMenuBar jMenuBar1;
    
}
