package org.jvisu.base;

import java.awt.*;
import java.text.*;
import java.beans.*;
import javax.swing.*;
import org.jvisu.comm.*;
import org.jvisu.util.param.JVParams;
import org.jvisu.comm.var.*;

/** Visual component to display numerical (double) values
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 *  <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation. See file LICENCE in this
 *  directory</p>
 * <p>
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 * </p>
 *  The purpose of JVDigits is to display a rectangular shape, which contains
 *  the numerical representation of a variable. The representation can be 
 *  customized by various methods.
 *  The components has a builtin min/max compare function, which can be custumized by 
 *  absolute values or variable values, which are retrieved from the communication server
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0
 */
public class JVHexByte extends JVHexDez {

    byte    val;
    
    /** Create a new instance ofJVHexShort
     */
    public JVHexByte() {
        // Build commvariable for act
        addCommVar (new JVVarCfg(null, updaterate, JVVar.T_BYTE, 0, 0));
        disphex = true;
    }

    /** Variable has changed */
    public void VarChanged (JVVar var) {
        val = ((JVVarByte)var).getVarValue();
        repaint();
    }
    
    /* Convert variable value to String */
    public String getVarString() {
        String txt;
        /* Hexdisplay ? */
        if (disphex) {
            // convert the value to the requested number format
            txt = Integer.toHexString(((int)val) & 0xFF);
            if (txt.length() == 1)
                return "0" + txt;
        } else
            txt = Byte.toString(val);
        return txt;
    }
}
