package org.jvisu.panel.configurator;

import java.awt.*;
import java.beans.*;
import javax.swing.*;
import javax.swing.border.*;

/** Cell panel
 *  <p>package:    org.jvisu.panel.configurator</p>
 *  <p>file:       JVCellPanel.java</p>
 * $Id: JVCellPanel.java,v 1.2 2004/04/19 08:20:55 tgl Exp $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 * Convenience class to hold property cells
 * </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.3
 */
public class JVCellPanel extends javax.swing.JPanel {
    
    private final static EtchedBorder   border = new EtchedBorder();
    
    /** Creates a new instance of JVCellPanel
     *  @param size size of this component
     *  @param font font descriptor
     */
    public JVCellPanel(Dimension size, Font font) {
        setBorder(border);
        setPreferredSize(size);
        setMinimumSize(size);
        Dimension sz = new Dimension(size); 
        sz.width = 32767;
        setMaximumSize(sz);
        setLayout(new BorderLayout());
        setFont(font);
    }
}